precision mediump float;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec2 v_texCoord1;
varying vec2 v_texCoord2;
varying vec2 v_texCoord3;
uniform mediump float startTime;
uniform mediump float inputParamX;
uniform mediump float inputParamY;

#define globalTime CC_Time[0]
#define iResolution CC_WinSize
#define iChannel0 CC_Texture0
#define iChannel1 CC_Texture1
#define iChannel2 CC_Texture2
#define iChannel3 CC_Texture3
#define textureCoordinate v_texCoord
#define textureCoordinate1 v_texCoord1
#define textureCoordinate2 v_texCoord2
#define textureCoordinate3 v_texCoord3
#define inputImageTexture iChannel0
#define inputImageTexture2 iChannel1
#define inputImageTexture3 iChannel2
#define inputImageTexture4 iChannel3

highp vec3 sample(highp vec2 uv, highp float mul)
{
    return texture2D(inputImageTexture, uv).xyz * mul;
}

highp float rlum(highp vec3 col)
{
    return dot(col, vec3(.2126, .7152, .0722));
}

void main(void)
{
    highp vec2 uv = textureCoordinate;
    highp vec3 ns = sample(uv, 1.);
    
    highp vec3 cl = vec3(1);
    
    highp float m = inputParamX;
    
    highp vec3 pixelColor = texture2D(inputImageTexture, uv).xyz;
    highp float pixelGrey = dot(pixelColor, vec3(1.0/3.0));
    cl = vec3(pixelGrey);
    
    highp vec3  frs = vec3(
                           uv.x  < m ? ns : cl
                           * smoothstep(0., .005, abs(m - uv.x))
                           );
    
    gl_FragColor = vec4(frs,1);
}